#include<stdio.h>
#include<stdlib.h>


// serveur SOAP
#include "messgH.h"
#include "messg.nsmap"


int ns__display(
struct soap *p_soap, // contexte d'excution du service web,
	int p_code, // entier (code)
	char *p_chaine, // chaine de caractere (message)
struct ns__noResponse *p_out // pas de rponse (out) 
	)
{
	int i;
	printf("Display\n");
	for (i = 0; i<p_code; i++) { printf("%s\n", p_chaine); }
	return SOAP_OK;
}

int main(int p_argc,char *p_argv[]) 
{
	struct soap v_soap;     // contexte du service SOAP

	// on initialise la socket
    soap_init(&v_soap);
	soap_set_namespaces(&v_soap, namespaces);

	// on cre la socket mre de connexion. Voir soap_bind

	if (soap_bind(&v_soap, NULL, 8060, 100) < 0) { return -1; }

	// on gre une boucle infinie pour recevoir les requtes
	for (;;) {
		v_soap.accept_timeout = 1; // on rend l'attente non bloquante
		if (soap_accept(&v_soap) < 0) { continue; }
		soap_serve(&v_soap);
		soap_destroy(&v_soap);  // dealloc data
		soap_end(&v_soap);  // dealloc data and cleanup
	}
	soap_done(&v_soap);   // dtache soap struct
}


